<%@ Assembly Name="Microsoft.SharePoint.ApplicationPages, Version=12.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c"%>
<%@ Page Language="C#"  MasterPageFile="~/_layouts/application.master" ValidateRequest="False" %> 
<%@ Import Namespace="Microsoft.SharePoint.ApplicationPages" %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<%@ Import Namespace="System.Xml" %>
<%@ Register Tagprefix="SharePoint" Namespace="Microsoft.SharePoint.WebControls" Assembly="Microsoft.SharePoint, Version=11.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Register Tagprefix="Utilities" Namespace="Microsoft.SharePoint.Utilities" Assembly="Microsoft.SharePoint, Version=11.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Register Tagprefix="SharePoint" Namespace="Microsoft.SharePoint.WebControls" Assembly="Microsoft.SharePoint, Version=12.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Register TagPrefix="wssuc" TagName="ButtonSection" src="~/_controltemplates/ButtonSection.ascx" %>
<%@ Register TagPrefix="wssuc" TagName="InputFormSection" src="~/_controltemplates/InputFormSection.ascx" %>
<%@ Register TagPrefix="wssuc" TagName="InputFormControl" src="~/_controltemplates/InputFormControl.ascx" %>

<asp:Content ContentPlaceHolderId="PlaceHolderPageTitle" runat="server">
	<SharePoint:EncodedLiteral runat="server" text="Reset theme for a site collection" EncodeMethod='HtmlEncode'/>
</asp:Content>
<asp:Content ContentPlaceHolderId="PlaceHolderAdditionalPageHead" runat="server">
</asp:Content>
<asp:Content ContentPlaceHolderId="PlaceHolderPageTitleInTitleArea" runat="server">
	<SharePoint:EncodedLiteral runat="server" text="Reset all site collection with theme" EncodeMethod='HtmlEncode'/>
</asp:Content>
<asp:Content ContentPlaceHolderId="PlaceHolderPageImage" runat="server">
	<img src="/_layouts/images/blank.gif" width="1" height="1" alt="blank" />
</asp:Content>
<asp:Content ContentPlaceHolderId="PlaceHolderPageDescription" runat="server">
	<SharePoint:EncodedLiteral runat="server" text="This page change all the sites and sub-sites for a collection to use the theme" EncodeMethod='HtmlEncode'/>
</asp:Content>
<asp:Content ContentPlaceHolderId="PlaceHolderMain" runat="server">
	<table  border="0" width="100%" cellspacing="0" cellpadding="0">

 <wssuc:InputFormSection Title="Theme management"
			Description="Choose your theme in the list"
			runat="server">
	   <Template_InputFormControls>
            <asp:DropDownList ID="DropDownListThemes" runat="server" Width="400"></asp:DropDownList>
	   </Template_InputFormControls>
 </wssuc:InputFormSection>

 <wssuc:InputFormSection Title="Logo Management"
			Description="Complete the Logo URL and alternate Text"
			runat="server">
	   <Template_InputFormControls>
        Change the Logo:  <asp:CheckBox ID="CheckBoxChangeLogo" runat="server" /><br />
        URL: <asp:TextBox ID="TextBoxLogoUrl" runat="server" Width="400"></asp:TextBox><br />
        Alternate Text: <asp:TextBox ID="TextBoxLogoDescription" runat="server" Width="400"></asp:TextBox>
	   </Template_InputFormControls>
 </wssuc:InputFormSection>

 <wssuc:InputFormSection Title="Result"
			Description="Result for the changes"
			runat="server">
	   <Template_InputFormControls>
	    <asp:literal ID="LiteralResult" runat="server" text="" />
	   </Template_InputFormControls>
 </wssuc:InputFormSection>

 <wssuc:InputFormSection Title="Site Settings"
			Description="Return to Site Settings page"
			runat="server">
	   <Template_InputFormControls>
            <asp:HyperLink ID="HyperLinkSiteSettings" runat="server"></asp:HyperLink>
	   </Template_InputFormControls>
 </wssuc:InputFormSection>
    <tr>
    <td colspan="2">
    	    <wssuc:ButtonSection runat="server">
				    <Template_Buttons>
					    <input type="submit" class="ms-ButtonHeightWidth" value="Apply Theme" id="Submit2" name="Submit2" ACCESSKEY="S" OnServerClick="Submit1_Click" runat="server"/>
				    </Template_Buttons>
			    </wssuc:ButtonSection>
    </td>
    </tr>
	</table>

<script language="C#" runat="server">

    /// <summary>
    /// On Load actions - Load all controls for the page
    /// </summary>
    /// <param name="e"></param>
    protected override void OnLoad(EventArgs e)
	{
        if (!this.IsPostBack)
        {
            try
            {
                using (SPWeb myNewWeb = SPControl.GetContextWeb(Context))
                {
                    this.TextBoxLogoDescription.Text = myNewWeb.SiteLogoDescription.ToString();
                    this.TextBoxLogoUrl.Text = myNewWeb.SiteLogoUrl;
                    LoadAllThemesInDDL((int)myNewWeb.Language, myNewWeb.Theme);

                    this.HyperLinkSiteSettings.Text = "Return to the Site Settings";
                    this.HyperLinkSiteSettings.NavigateUrl = myNewWeb.Url + "/_layouts/settings.aspx";
                }
            }
            catch (Exception Myexception)
            {
                this.LiteralResult.Text += "Error: " + Myexception.ToString();
            }
        }
	}

    /// <summary>
    /// Change the theme
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void Submit1_Click(object sender, EventArgs e)
    {
        string DefinedTheme = DropDownListThemes.SelectedValue;
        using (SPWeb myNewWeb = SPControl.GetContextWeb(Context))
		{
            this.LiteralResult.Text += "Selected Theme: " + DefinedTheme +"<BR>";
            updateThemeWeb(myNewWeb, DefinedTheme);
        }
    }
    
    /// <summary>
    /// Set the Theme for the Web and call this function for each child site
    /// </summary>
    /// <param name="web">SPWeb for change Theme</param>
    /// <param name="ThemeName">Theme name</param>
    private void updateThemeWeb(SPWeb web, string ThemeName)
	{
        this.LiteralResult.Text += "URL: " + web.Url + "<BR>";
        this.LiteralResult.Text += "Choosed theme: " + ThemeName + "<BR>";
        try
        {
            web.AllowUnsafeUpdates = true;
            if (this.CheckBoxChangeLogo.Checked == true)
            {
                web.SiteLogoUrl = this.TextBoxLogoUrl.Text.Trim();
                web.SiteLogoDescription = this.TextBoxLogoDescription.Text.Trim();
                this.LiteralResult.Text += "Logo: <B>OK</B><BR>";
            }
            web.ApplyTheme(ThemeName);
            web.Update();
            this.LiteralResult.Text += "Theme: <B>OK</B><BR>";
        }
        catch (Exception MyException)
        {
            this.LiteralResult.Text += "Error: " + MyException.ToString() + "<BR>";
        }
		foreach (SPWeb subweb in web.GetSubwebsForCurrentUser())
		{
			updateThemeWeb(subweb, ThemeName);
		}
		web.Dispose();
	}

    /// <summary>
    /// Load value in The theme DropDown List
    /// </summary>
    /// <param name="WebLCID">Current language LCID</param>
    /// <param name="ActualTheme">Current theme</param>
    private void LoadAllThemesInDDL(int WebLCID, string CurrentTheme)
    {
        string content;
        try
        {
            this.DropDownListThemes.Items.Clear();
            string filePath = Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles) + @"\Microsoft Shared\web server extensions\12\TEMPLATE\LAYOUTS\"+ WebLCID + @"\SPTHEMES.XML";
            if (!System.IO.File.Exists(filePath))
            {
                this.LiteralResult.Text += "Unable to find SPTHEMES.XML at " + filePath;
            }
            using (System.IO.TextReader tr = new System.IO.StreamReader(filePath))
            {
                content = tr.ReadToEnd();
            }
            XmlDocument xDoc = new XmlDocument();
            xDoc.LoadXml(content);
            int count = 0;
            foreach (XmlNode xNode in xDoc.DocumentElement.ChildNodes)
            {
                string themeID = xNode["TemplateID"].InnerXml;
                this.DropDownListThemes.Items.Add(new ListItem(themeID.ToUpper(), themeID));
            }
            this.DropDownListThemes.Items.FindByText(CurrentTheme.ToUpper()).Selected = true;
        }
        catch (Exception ex)
        {
            this.LiteralResult.Text += "<BR>Error: " + ex.Message;
        }
    }
</script>

</asp:Content>